#include <stdio.h>
#include <gsl/gsl_randist.h>

#define K 3

int main(void)
{
	int i, j;
	double th[K], x1, x2, x3;
	double a[K] = {1.3, 1.5, 1.2};

	puts("set terminal epslatex");
	puts("set output \"dirichlet.tex\"");
	puts("set view 47.0, 72.0");
	puts("set title \"Dirichlet Distribution\"");
	puts("set xlabel \"$\\\\theta_1$\"");
	puts("set ylabel \"$\\\\theta_2$\"");
	puts("set zlabel \"$p(\\\\theta)$\" -4.0, -1.0");
	puts("set ticslevel 0");
	puts("splot [0:1][0:1] \"-\" title \"$\\\\alpha_i=1.3,1.5,1.2$\" with lines");
	for (i = 0; i < 50; i++) {
		x1 = 0.02 * i;
		for (j = 0; j < 50; j++) {
			x2 = 0.02 * j;
			x3 = 1.0 - x1 - x2;
			th[0] = x1; th[1] = x2; th[2] = x3;
			if (x3 < 0) {
				printf("%f\t%f\t%s\n", x1, x2, "0/0");
			} else {
				printf("%f\t%f\t%f\n", x1, x2, gsl_ran_dirichlet_pdf(K, a, th));
			}
		}
		printf("\n");
	}

	return 0;
}
