#include <stdio.h>
#include <gsl/gsl_randist.h>

#define N 10
#define K  3

int main()
{
	int k1, k2;
	unsigned int n[K];
	double       p[] = { 0.2, 0.3, 0.5 };

	puts("set pointsize 2");
	puts("set terminal epslatex");
	puts("set output \"multinomial.tex\"");
	puts("set title \"Multinomial Distribution\"");
	puts("set xlabel \"$n_1$\"");
	puts("set ylabel \"$n_2$\"");
	puts("set zlabel \"$P(n_i)$\"");
	puts("set xtics 1.0");
	puts("set ytics 1.0");
	puts("set grid xtics ytics");
	puts("set ticslevel 0");
	puts("splot [-0.5:10.5][-0.5:10.5][0:0.1] \"-\""
	     "title \"$n_3=10-n_1-n_2,~p_k = 0.2,0.3,0.5$\" with impulses lw 5");
	for (k1 = 0; k1 <= 10; k1++) {
		for (k2 = 0; k2 <= 10 - k1; k2++) {
			n[0] = k1; n[1] = k2; n[2] = N - k1 - k2;
			printf("%d\t%d\t%f\n", k1, k2, gsl_ran_multinomial_pdf(K, p, n));
		}
		for (k2 = 11 - k1; k2 <= 10; k2++) printf("%d\t%d\t0.0\n", k1, k2);
		printf("\n");
	}

	return 0;
}
